Exit code at the end of a bash script

The builtin command exit exits the shell (from Bash's reference):

exit [n]
Exit the shell, returning a status of n to the shell’s parent. If n is omitted, the exit status is that of the last command executed. Any trap on EXIT is executed before the shell terminates.

Running to the end of file also exits, returning the return code of the last command, so yes, a final exit 0 will make the script exit with successful status regardless of the exit status of the previous commands. (That is, assuming the script reaches the final exit.) At the end of a script you could also use true or : to get an exit code of zero.

Of course more often you'd use exit from inside an if to end the script in the middle.

These should print a 1 ($? contains the exit code returned by the previous command):

sh -c "false" ; echo $?
sh -c "false; exit" ; echo $?

While this should print a 0:

sh -c "false; exit 0" ; echo $?

I'm not sure if the concept of the script "failing" when executing an exit makes sense, as it's quite possible to some commands ran by the script to fail, but the script itself to succeed. It's up to the author of the script to decide what is a success and what isn't.

Also, the standard range for exit codes is 0..255. Codes above 127 are used by the shell to indicate a process terminated by a signal, but they can be returned in the usual way. The wait system call actually returns a wider value, with the rest containing status bits set by the operating system.


0 means success, positive integers mean failure. There are 255 different error codes, but values 126 and above are reserved to indicate that a program couldn't start (126 or 127) or was killed by a signal (129 and above). See Default exit code when process is terminated? and What return/exit values can I use in bash functions/scripts? for more information.

The exit status of a shell script is the exit status of the last command that the script executed. So for example

#!/bin/sh
somecommand

returns the exit status of somecommand, whereas

#!/bin/sh
somecommand
exit 0

returns 0 regardless of what somecommand returned. This second script could also be written

#!/bin/sh
somecommand
true

Putting exit 0 at the end of a script doesn't necessarily cause it to return 0. This only makes it return 0 when the end of the script is reached. For example, the following script always returns 3:

#!/bin/sh
exit 3
exit 0

The following script also always returns an error code, in addition to displaying a message about a syntax error:

#!/bin/sh
}
exit 0

The following script returns either 1 or 0 depending on its first argument:

#!/bin/sh
if [ "$1" = "foo" ]; then
  exit 1
fi
exit 0

The following script returns the status of somecommand, since set -e causes the script to exit if somecommand fails:

#!/bin/sh
set -e
somecommand
exit 0